package allrounder;

public class IdString implements Comparable<IdString> {
	private int ID;
	private String compareString;
	private String displayString;
	private String tooltipString;
	public IdString(int id, String string) {
		this.ID = id;
		this.compareString = string;
		this.displayString = this.compareString.replace("~", "").replace("!", "");
	}
	
	public IdString(int id, String string, String tooltip) {
		this(id, string);
		setToolTipText(tooltip);
	}
	
	public int getID() {
		return this.ID;
	}
	
	public String getString() {
		return this.displayString;
	}
	
	@Override
	public String toString() {
		return this.displayString;
	}
	
	public void setToolTipText(String tooltip) {
		this.tooltipString = tooltip;
	}
	
	public String getToolTipText() {
		return this.tooltipString;
	}

	public int compareTo(IdString o) {
		return this.compareString.compareToIgnoreCase(o.compareString);
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + this.ID;
		result = prime * result
				+ ((this.compareString == null) ? 0 : this.compareString.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		IdString other = (IdString) obj;
		if (this.ID != other.ID) return false;
		if (this.compareString == null) {
			if (other.compareString != null) return false;
		} else if (!this.compareString.equals(other.compareString)) {
			return false;
		}
		return true;
	}
}
