package allrounder;

import javax.swing.DefaultListModel;

public class SortedListModel extends DefaultListModel {
	private static final long serialVersionUID = 2645134459924191924L;
	private int indexOfLastAdded = 0;
	
	@Override
	public void add(int index, Object element) {
		addElement(element);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public void addElement(Object obj) {
		if (!(obj instanceof Comparable)) throw new IllegalArgumentException();
		for (int i = 0; i < this.getSize(); ++i) {
			int res = ((Comparable)this.getElementAt(i)).compareTo(obj);
			if (res >= 0) {
				// actual element in list is larger or same than obj
				super.add(i, obj);
				this.indexOfLastAdded = i;
				return;
			}
		}
		// the list seems to be empty or everything is smaller than obj
		super.addElement(obj);
	}
	
	public int getIndexOfLastAdded() {
		return this.indexOfLastAdded;
	}
}
