package allrounder.logger;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Calendar;
import java.util.TimeZone;

import allrounder.DirHandler;

public class Logwriter {
	private static Logwriter ref = null;
	PrintStream print = null;
	
	private Logwriter() {
		try {
			File file = new File(DirHandler.getAppDataDir(), "log.txt");
			if (file.exists()) {
				if (file.length() > (10 * 1024 * 1024)) { // gr�sser als 10 mega
					file.delete();
					file.createNewFile();
				}
			} else {
				file.createNewFile();
			}
			
			FileOutputStream out = new FileOutputStream(file, true);
			this.print = new PrintStream(out);
			this.print.println();
			this.print.println();
			this.print.println();
			Calendar cal = Calendar.getInstance();
			cal.setTimeZone(TimeZone.getTimeZone("GMT+1"));
			String sDate = cal.get(Calendar.DAY_OF_MONTH) + "." + (cal.get(Calendar.MONTH) + 1) + "." + cal.get(Calendar.YEAR);
			String sTime = cal.get(Calendar.HOUR_OF_DAY) + ":" + cal.get(Calendar.MINUTE);
			this.print.println(sDate + "  " + sTime);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static synchronized Logwriter getInstance()
    {
      if (ref == null) {
          ref = new Logwriter();
      }
      return ref;
    }
	
	public void writeLine(String sLine, boolean bError) {
		if (bError) {
			System.err.println(sLine);
		} else {
			System.out.println(sLine);
		}
		if (bError) this.print.print("ERROR:  ");
		this.print.println(sLine);
	}
	
	public PrintStream getPrintStream() {
		return this.print;
	}
	
	public void destruct() {
		if (this.print != null) this.print.close();
	}
}
