package index;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.TreeSet;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.SwingConstants;

import allrounder.DbHandler;
import allrounder.StringLib;
import allrounder.TaggedImage;

public class TagPanel extends JPanel implements ActionListener {
	private static final long serialVersionUID = -1147465484285569341L;

	StringLib lib = StringLib.getInstance();
	
	JLabel lblHeadCount;
	JLabel lblArtist;
	JLabel lblSex;
	JLabel lblOther1;
	JLabel lblOther2;
	
	JTextField jtfHeadCount = new JTextField();
	AutoCompletionTextField jtfArtist = new AutoCompletionTextField(',', new ArrayList<String>());
	JTextPane jtpSpecies = new JTextPane();
	AutoCompletionTextPane jtpOther = new AutoCompletionTextPane(',', new ArrayList<String>());
	JTextPane jtpYiff = new JTextPane();
	
	JButton btnSpecies;
	JButton btnFetish;
	
	JCheckBox chkGender0;
	JCheckBox chkGender1;
	JCheckBox chkGender2;
	JCheckBox chkGender3;
	JCheckBox chkGender4;
	JCheckBox chkYiff;
	
	SpeziesChooserDialog speziesDialog = new SpeziesChooserDialog();
	FetishChooserDialog fetishDialog = new FetishChooserDialog();
	
	TaggedImage origImg = null;
	
	public TagPanel() {
		this.lblHeadCount = makeLabel(this.lib.getValue("Tag.headcount.text"), this.lib.getValue("Tag.headcount.tt"));
		this.lblArtist = makeLabel(this.lib.getValue("Tag.artist.text"), this.lib.getValue("Tag.artist.tt"));
		this.lblSex = makeLabel(this.lib.getValue("Tag.sex.text"), this.lib.getValue("Tag.sex.tt"));
		this.lblOther1 = makeLabel(this.lib.getValue("Tag.other.text"), null);
		this.lblOther2 = makeLabel(this.lib.getValue("Tag.other.second.text"), null);
		
		this.btnSpecies = makeButton(this.lib.getValue("Tag.choosespezies.text"), "SPECIES", this.lib.getValue("Tag.choosespezies.tt"));
		this.btnFetish = makeButton(this.lib.getValue("Tag.fetish.text"), "FETISH", this.lib.getValue("Tag.fetish.tt"));
		this.btnFetish.setEnabled(false);
		
		this.chkGender0 = makeCheckBox(this.lib.getValue("Tag.sex.0.text"), this.lib.getValue("Tag.sex.0.tt"));
		this.chkGender1 = makeCheckBox(this.lib.getValue("Tag.sex.1.text"), this.lib.getValue("Tag.sex.1.tt"));
		this.chkGender2 = makeCheckBox(this.lib.getValue("Tag.sex.2.text"), this.lib.getValue("Tag.sex.2.tt"));
		this.chkGender3 = makeCheckBox(this.lib.getValue("Tag.sex.3.text"), this.lib.getValue("Tag.sex.3.tt"));
		this.chkGender4 = makeCheckBox(this.lib.getValue("Tag.sex.4.text"), this.lib.getValue("Tag.sex.4.tt"));
		this.chkYiff = makeCheckBox(this.lib.getValue("Tag.yiff.text"), this.lib.getValue("Tag.yiff.tt"));
		this.chkYiff.setActionCommand("YIFF");
		this.chkYiff.addActionListener(this);
		
		this.jtpSpecies.setEditable(false);
		this.jtpSpecies.setBackground(this.getBackground());
		this.jtpYiff.setEditable(false);
		this.jtpYiff.setBackground(this.getBackground());
		
		int lblOtherWith = (this.lblOther2.getPreferredSize().width > this.lblOther1.getPreferredSize().width) ? this.lblOther2.getPreferredSize().width : this.lblOther1.getPreferredSize().width;
		//					---> waagrecht
		double[][] layout = {{this.lblHeadCount.getPreferredSize().width, 10, 50, TableLayoutConstants.FILL, this.chkGender2.getPreferredSize().width, this.chkGender2.getPreferredSize().width, TableLayoutConstants.FILL, lblOtherWith, TableLayoutConstants.FILL, this.btnFetish.getPreferredSize().width},
							 // senkrecht
							 {new JButton("dummy").getPreferredSize().height, this.chkGender1.getPreferredSize().height, this.chkGender1.getPreferredSize().height, this.chkGender1.getPreferredSize().height, 3, this.chkYiff.getPreferredSize().height, this.btnFetish.getPreferredSize().height}};
		
		setLayout(new TableLayout(layout));
		
		//adding: 3 parts top to bottom, left to right
		//part 1
		add(this.lblHeadCount, "0, 0");
		add(this.jtfHeadCount, "2, 0");
		add(this.btnSpecies, "0, 1, 2, 1");
		add(new JScrollPane(this.jtpSpecies), "0, 2, 2, 3");
		add(this.lblArtist, "0, 5, 2, 5");
		add(this.jtfArtist, "0, 6, 2, 6");
		
		//separator
		add(new JSeparator(SwingConstants.VERTICAL), "3, 0, 3, 6, c, f");
		
		// part 2
		add(this.lblSex, "4, 0, 5, 0");
		add(this.chkGender0, "4, 1");
		add(this.chkGender1, "5, 1");
		add(this.chkGender2, "4, 2");
		add(this.chkGender3, "5, 2");
		add(this.chkGender4, "4, 3, 5, 3");
		//add(new JSeparator(JSeparator.HORIZONTAL), "4, 4, 5, 4");
		//add(chkYiff, "4, 5");
		//add(btnFetish, "4, 6, 5, 6");
		
		//separator
		add(new JSeparator(SwingConstants.VERTICAL), "6, 0, 6, 6, c, f");
		
		// part 3
		add(this.lblOther1, "7, 0");
		add(this.lblOther2, "7, 1");
		add(new JScrollPane(this.jtpOther), "7, 2, 7, 6");
		
		//separator
		add(new JSeparator(SwingConstants.VERTICAL), "8, 0, 8, 6, c, f");
		
		// part 4
		add(this.chkYiff, "9, 0");
		add(this.btnFetish, "9, 1");
		add(new JScrollPane(this.jtpYiff), "9, 2, 9, 6");
		
		setAllEnabled(false);
	}
	
	private JButton makeButton(String text, String actionCommand, String toolTipText) {
		// Create and initialize the button.
		JButton button = new JButton(text);
		button.setActionCommand(actionCommand);
		button.setToolTipText(toolTipText);
		button.addActionListener(this);
		return button;
	}
	
	private JLabel makeLabel(String text, String toolTipText) {
		JLabel label = new JLabel(text);
		if (toolTipText != null) label.setToolTipText(toolTipText);
		return label;
	}
	
	private JCheckBox makeCheckBox(String text, String toolTipText) {
		JCheckBox box = new JCheckBox(text);
		box.setToolTipText(toolTipText);
		return box;
	}

	public void actionPerformed(ActionEvent ae) {
		String command = ae.getActionCommand();
		if (command.equalsIgnoreCase("YIFF")) {
			this.btnFetish.setEnabled(this.chkYiff.isSelected());
		} else if (command.equalsIgnoreCase("SPECIES")) {
			this.speziesDialog.setLocationRelativeTo(this.getParent());
			int retVal = this.speziesDialog.displaySpeziesChooserDialog();
			if (retVal == SpeziesChooserDialog.SAVE) {
				StringBuilder species = new StringBuilder("");
				TreeSet<Integer> Ids = this.speziesDialog.getSpeciesIds();
				if (Ids.size() == 0) {
					this.jtpSpecies.setText("");
					return;
				}
				for (Integer i : Ids) {
					species.append(this.lib.getValue("species." + i) + ", ");
				}
				// remove the last 2 chars which are ", "
				species.delete(species.length() - 2, species.length());
				this.jtpSpecies.setText(species.toString());
			}
		} else if (command.equalsIgnoreCase("FETISH")) {
			this.fetishDialog.setLocationRelativeTo(this.getParent());
			int retVal = this.fetishDialog.displayFetishChooserDialog();
			if (retVal == SpeziesChooserDialog.SAVE) {
				StringBuilder fetishes = new StringBuilder("");
				TreeSet<Integer> Ids = this.fetishDialog.getFetishIds();
				if (Ids.size() == 0) {
					this.jtpYiff.setText("");
					return;
				}
				for (Integer i : Ids) {
					fetishes.append(this.lib.getValue("fetishchooser.fetishes." + i + ".text") + ", ");
				}
				
				// remove the last 2 chars which are ", "
				fetishes.delete(fetishes.length() - 2, fetishes.length());
				this.jtpYiff.setText(fetishes.toString());
			}
		}
	}
	
	public TaggedImage getTags() {
		TaggedImage img = new TaggedImage();
		int headcount;
		try {
			headcount = Integer.parseInt(this.jtfHeadCount.getText());
		} catch (NumberFormatException nfe) {
			headcount = 0;
		}
		if (headcount > 0) {
			if (headcount >= 128) {
				img.headcount = 127; // the table in the DB is TINYINT, ergo 0-127
			} else {
				img.headcount = headcount;
			}
		}
		
		img.spezies = this.speziesDialog.getSpeciesIds();
		
		String artists = this.jtfArtist.getText().trim();
		if (!artists.equals("")) {
			String[] a = artists.split(",");
			for (String s : a) {
				s = s.trim();
				if (!s.equals("")) {
					img.artists.add(s);
				}
			}
		}
		
		if (this.chkGender0.isSelected()) {
			img.gender.add(0);
		}
		if (this.chkGender1.isSelected()) {
			img.gender.add(1);
		}
		if (this.chkGender2.isSelected()) {
			img.gender.add(2);
		}
		if (this.chkGender3.isSelected()) {
			img.gender.add(3);
		}
		if (this.chkGender4.isSelected()) {
			img.gender.add(4);
		}
		
		String other = this.jtpOther.getText().trim();
		if (!other.equals("")) {
			String[] o = other.split(",");
			for (String s : o) {
				s = s.trim();
				if (!s.equals("")) {
					img.other.add(s);
				}
			}
		}
		
		img.fetish = this.fetishDialog.getFetishIds();
		
		img.yiff = this.chkYiff.isSelected();
		
		return img;
	}
	
	public void setAllEnabled(boolean b) {
		this.jtfHeadCount.setEnabled(b);
		this.jtfArtist.setEnabled(b);
		this.jtpOther.setEnabled(b);
		
		this.btnSpecies.setEnabled(b);
		this.btnFetish.setEnabled(b);
		
		this.chkGender0.setEnabled(b);
		this.chkGender1.setEnabled(b);
		this.chkGender2.setEnabled(b);
		this.chkGender3.setEnabled(b);
		this.chkGender4.setEnabled(b);
		this.chkYiff.setEnabled(b);
	}
	
	public void reset() {
		this.origImg = null;
		setAllEnabled(true);
		this.jtfHeadCount.setText("");
		this.speziesDialog = new SpeziesChooserDialog();
		this.jtpSpecies.setText("");
		this.jtfArtist.setText("");
		this.chkGender0.setSelected(false);
		this.chkGender1.setSelected(false);
		this.chkGender2.setSelected(false);
		this.chkGender3.setSelected(false);
		this.chkGender4.setSelected(false);
		this.jtpOther.setText("");
		this.fetishDialog = new FetishChooserDialog();
		this.jtpYiff.setText("");
		this.chkYiff.setSelected(false);
		this.btnFetish.setEnabled(false);
	}
	
	public void setTags(TaggedImage img) {
		reset();
		if (img.isEmpty()) {
			this.jtfArtist.setWords(DbHandler.getInstance().getArtists());
			this.jtpOther.setWords(DbHandler.getInstance().getOthers());
			return;
		}
		this.jtfHeadCount.setText("" + img.headcount);
		
		this.speziesDialog.setSpeciesIds(img.spezies);
		StringBuilder species = new StringBuilder("");
		for (Integer i : img.spezies) {
			species.append(this.lib.getValue("species." + i) + ", ");
		}
		// remove the last 2 chars which are ", "
		if (species.length() != 0) species.delete(species.length() - 2, species.length());
		this.jtpSpecies.setText(species.toString());
		
		StringBuilder artists = new StringBuilder("");
		for (String str : img.artists) {
			artists.append(str + ", ");
		}
		if (artists.length() != 0) artists.delete(artists.length() - 2, artists.length());
		this.jtfArtist.setText(artists.toString());
		this.jtfArtist.setWords(DbHandler.getInstance().getArtists());

		for (int i : img.gender) {
			if (i == 0) this.chkGender0.setSelected(true);
			if (i == 1) this.chkGender1.setSelected(true);
			if (i == 2) this.chkGender2.setSelected(true);
			if (i == 3) this.chkGender3.setSelected(true);
			if (i == 4) this.chkGender4.setSelected(true);
		}
		
		StringBuilder other = new StringBuilder("");
		for (String str : img.other) {
			other.append(str + ", ");
		}
		if (other.length() != 0) other.delete(other.length() - 2, other.length());
		this.jtpOther.setText(other.toString());
		this.jtpOther.setWords(DbHandler.getInstance().getOthers());
		
		this.fetishDialog.setFetishIds(img.fetish);
		StringBuilder fetish = new StringBuilder("");
		for (Integer i : img.fetish) {
			fetish.append(this.lib.getValue("fetishchooser.fetishes." + i + ".text") + ", ");
		}
		if (fetish.length() != 0) fetish.delete(fetish.length() - 2, fetish.length());
		this.jtpYiff.setText(fetish.toString());
		
		this.chkYiff.setSelected(img.yiff);
		this.btnFetish.setEnabled(img.yiff);
		this.origImg = getTags();
		this.jtfHeadCount.requestFocusInWindow();
	}
	
	public boolean hasChanged() {
		if (this.origImg == null) {
			if (!getTags().isEmpty()) return true;
			return false;
		}
		return !this.origImg.equals(getTags());
	}
}
