package search;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;

import javax.swing.Icon;
import javax.swing.JButton;

class CloseIcon implements Icon{
    private boolean rollover;
    private static int buttonSize = 17;
    
    public CloseIcon(boolean rollover){
        this.rollover = rollover;
    }
    public void paintIcon(Component c, Graphics g, int x, int y) {
        Graphics2D g2 = (Graphics2D) g;
        Stroke stroke = g2.getStroke();
        g2.setStroke(new BasicStroke(2));
        g.setColor(Color.BLACK);
        if (this.rollover) g.setColor(Color.RED);
        g.drawLine(6, 6, getIconWidth() - 7, getIconHeight() - 7);
        g.drawLine(getIconWidth() - 7, 6, 6, getIconHeight() - 7);
        g2.setStroke(stroke);
    }
    
    public int getIconWidth() {
    	return buttonSize;
    }
    
    public int getIconHeight() {
    	return buttonSize;
    }
    
    public static JButton getCloseButton() {
    	JButton btnClose = new JButton(new CloseIcon(false));
		btnClose.setContentAreaFilled(false);
        btnClose.setRolloverEnabled(true);
        btnClose.setRolloverIcon(new CloseIcon(true));
        //btnClose.setUI(new BasicButtonUI());
        btnClose.setPreferredSize(new Dimension(buttonSize, buttonSize));
        return btnClose;
    }
}