package search;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.TreeSet;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import allrounder.IdString;
import allrounder.StringLib;
import allrounder.TaggedImage;

public class YiffSearchField extends JPanel implements SearchInterface, ActionListener {
	private static final long serialVersionUID = -1202440453960950611L;
	boolean bAddCloseButton = true;
	JButton btnClose = CloseIcon.getCloseButton();
	JLabel lblFetish = new JLabel(StringLib.getInstance().getValue("search.FetishSearchField.fetish"));
	JLabel lblOr = new JLabel(StringLib.getInstance().getValue("search.SearchInterface.or"));
	JCheckBox chkYiff;
	JComboBox jcbFetish;
	JCheckBox chkInvert = new JCheckBox(StringLib.getInstance().getValue("search.SearchInterface.invert"));
	Vector<ActionListener> listeners = new Vector<ActionListener>();
	
	public YiffSearchField(boolean b, ActionListener al) {
		this.bAddCloseButton = b;
		this.listeners.add(al);
		construct();
	}
	
	public YiffSearchField(ActionListener al) {
		this.listeners.add(al);
		construct();
	}
	
	public void addActionListener(ActionListener al) {
		this.listeners.add(al);
	}
	
	private void construct() {
		StringLib lib = StringLib.getInstance();
		
		this.chkYiff = new JCheckBox(lib.getValue("Tag.yiff.text"));
		this.chkYiff.setToolTipText(lib.getValue("Tag.yiff.tt"));
		this.chkYiff.setBackground(Color.WHITE);
		this.chkYiff.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				YiffSearchField.this.jcbFetish.setEnabled(YiffSearchField.this.chkYiff.isSelected());
				YiffSearchField.this.chkInvert.setEnabled(YiffSearchField.this.chkYiff.isSelected());
			}
		});
		
		// get fetishes
		Vector<IdString> vFetish = new Vector<IdString>();
		vFetish.add(new IdString(-1, lib.getValue("search.FetishSearchField.nofetish")));
		vFetish.add(new IdString(-2, lib.getValue("search.FetishSearchField.whatever")));
		int fetishno = 0;
		while(true) {
			try {
				String tmp = lib.getValue("fetishchooser.fetishes." + fetishno + ".text");
				vFetish.add(new IdString(fetishno, tmp));
			} catch (IllegalArgumentException e) {
				// this WILL be thrown because i just iterate as long as there is no entry left
				break;
			}
			++fetishno;
		}
		java.util.Collections.sort(vFetish);
		this.jcbFetish = new JComboBox(vFetish);
		this.jcbFetish.setEnabled(false);
		this.chkInvert.setBackground(Color.WHITE);
		this.chkInvert.setEnabled(false);
		
		//column / row
		double[][] layout = {{this.btnClose.getPreferredSize().width + 10, 10, this.lblOr.getPreferredSize().width, 10, this.chkYiff.getPreferredSize().width, 10, this.lblFetish.getPreferredSize().width, 10, this.jcbFetish.getPreferredSize().width, 10, this.chkInvert.getPreferredSize().width},{TableLayoutConstants.FILL, this.jcbFetish.getPreferredSize().height, TableLayoutConstants.FILL}};
		this.setLayout(new TableLayout(layout));
		
		if (this.bAddCloseButton) {
			this.btnClose.setActionCommand("SUBCLOSE");
			this.btnClose.addActionListener(this);
			this.btnClose.setToolTipText(StringLib.getInstance().getValue("search.SearchCriteriaPanel.btnClose.tt"));
			add(this.btnClose, "0, 0, 0, 2, c, c");
			add(this.lblOr, "2, 0, 2, 2, c, c");
		}
		
		add(this.chkYiff, "4, 1");
		add(this.lblFetish, "6, 1");
		add(this.jcbFetish, "8, 1");
		add(this.chkInvert, "10, 1");
	}
	
	@Override
	public TreeSet<TaggedImage> filterImages(TreeSet<TaggedImage> images) {
		TreeSet<TaggedImage> resultSet = new TreeSet<TaggedImage>();
		Iterator<TaggedImage> it = images.iterator();
		while (it.hasNext()) {
			TaggedImage img = it.next();
			if (isValid(img)) {
				resultSet.add(img);
			}
		}
		
		return resultSet;
	}
	
	private boolean isValid(TaggedImage img) {
		if (this.chkYiff.isSelected()) {
			if (!img.yiff) return false;
		} else {
			if (img.yiff) return false;
		}
		
		int id = ((IdString)this.jcbFetish.getSelectedItem()).getID();
		if (id == -1) { // no fetish
			if (img.fetish.size() == 0) return this.chkInvert.isSelected() ? false : true;
		} else if (id == -2) { // every fetish
			return true;
		//} else if (id == 20) {  // i can't remember what this was for :(
		//	if (img.fetish.size() != 0) return true;
		} else if (img.fetish.contains(id)) {
			return this.chkInvert.isSelected() ? false : true;
		}
		return this.chkInvert.isSelected() ? true : false;
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getActionCommand().equalsIgnoreCase("SUBCLOSE")) {
			arg0.setSource(this);
			for (ActionListener al : this.listeners) {
				al.actionPerformed(arg0);
			}
		}
	}

}
